def tipDataCalend = 'Date'
def tipNumeric = 'Number'
def tipString = 'String'
def spatiiStangaMsg = "..."

def paramsProfiluri = [:]

def sqlSelectProfiluri = """
 SELECT
  PROFILURI.ID IDPROFIL
 FROM TOTAL.PROFILURI PROFILURI
 WHERE PROFILURI.ID_FIRMA = :idFirma
   AND PROFILURI.ID_USER  = :idUser
   AND PROFILURI.IMPLICIT = 1
 """

/* Nu este necesara definirea variabilelor "locale", "idFirma", "idUser",
   deoarece acestea sunt deja injectate ca proprietate. */

def idProfil = null // !!! Ar fi trebuit injectata ca proprietate (cf. discutiei cu John, din data de Luni 25.10.2021).
                    // Solutie provizorie, cf. discutiei pe Spark din data de Vineri 15.10.2021 cu CTO Costin Arsene;
                    // discutat si confirmat Luni 18.10.2021, de catre DD Cosmin C-tin

paramsProfiluri<<['idFirma':idFirma]
paramsProfiluri<<['idUser':idUser]

sql.eachRow(sqlSelectProfiluri, paramsProfiluri, {rsProfiluri ->
 if (debug) {
    println("idprofil = ${rsProfiluri.idprofil}")
 }
 
 idProfil = rsProfiluri.idprofil
})

if (debug) {
   println("Parametrii: " + parameters[])
   println("Parametru 'nrTranz': " + parameters['nrTranz'])
}

def nrTranzCamp = parameters['nrTranz']
def fileDefTrImobSIN = files['imobiliz']

def numeFisErr = 'Erori.xlsx'

def inregTotale = 0
def inregAdaugate = 0
def inregNecorespunzatoare = 0
def randuriIgnorate = 0


/* --> Variabile specifice pt. Preluare Imobiliz, cu valoare fixa, scrisa in clar */
def tiptranzValFixa = 'I'
def tipdocValFixa = 'SIN'

def stareValFixa = 'ACTIV'

def qdocValFixa = 1

def tipintValFixa = 'RECEPTIE'
def tiptranzactieValFixa = 'NORMALA'
def stornatValFixa = 'NU'
def ramanemfValFixa = 'DA'
def calcamfiscValFixa = 'NU'
def impozitValFixa = 'NU'
def calcamaltValFixa = 'NU'
/* <-- Variabile specifice pt. Preluare Imobiliz, cu valoare fixa, scrisa in clar */


def suntErr = false
def suntWrn = false

def fields = jsonRemoting.invokeRemote("EMSYS_ASSETS", "defTrimobQueryBuilder", "getColumnLabels", [locale]).remoteSimpleObject

if (debug) {
   println("Campurile: ${fields}")
}

def cloneWb = null
def cloneSheet = null
def liniiOK = []
def iduriInregAdaugate = []
def mesajeList = []

def style = null


def paramsTrImob = [:]
def paramsCodClas = [:]

def sqlSelectTrImob = """
 SELECT
  TRIMOB.ID_ANFISCAL IDANFISCAL,
  TRIMOB.ID_PERIOADA IDPERIOADA,
  DOCUMENT.CODDOC,
  TRIMOB.NRDOC,
  TRIMOB.DATADOC
 FROM
  TOTAL.TRIMOB TRIMOB,
  TOTAL.DOCUMENT DOCUMENT
 WHERE TRIMOB.ID_FIRMA    = :idFirma
   AND TRIMOB.NRTRANZ     = :nrTranz
   AND DOCUMENT.ID_FIRMA  = TRIMOB.ID_FIRMA
   AND DOCUMENT.ID        = TRIMOB.ID_CODDOC
 """

def sqlSelectCodClas = """
 SELECT
  CODCLAS.TIPIMOBILIZ,
  CODCLAS.CONTAMORTIZ
 FROM TOTAL.CODCLAS CODCLAS
 WHERE CODCLAS.ID_FIRMA = :idFirma
   AND CODCLAS.CODCLAS  = :codclas
   AND CODCLAS.DATAINC  = 
        (SELECT
          MAX(CODCL_CAUT.DATAINC)
         FROM
          TOTAL.CODCLAS CODCL_CAUT
         WHERE CODCL_CAUT.ID_FIRMA  = :idFirma
           AND CODCL_CAUT.CODCLAS   = :codclas
           AND CODCL_CAUT.DATAINC  <= :datainc)
 """


def idAnfiscalSQL = null
def idPerioadaSQL = null
def coddocMSQL = null
def nrdocmSQL = null
def datadocmSQL = null

paramsTrImob<<['idFirma':idFirma]
paramsTrImob<<['nrTranz':nrTranzCamp]

sql.eachRow(sqlSelectTrImob, paramsTrImob, {rsTrImob ->
   if (debug) {
      println("CodDoc = ${rsTrImob.coddoc}; NrDoc = ${rsTrImob.nrdoc}; DataDoc = ${rsTrImob.datadoc}")
   }
   
   idAnfiscalSQL = rsTrImob.idanfiscal
   idPerioadaSQL = rsTrImob.idperioada
   coddocMSQL = rsTrImob.coddoc
   nrdocmSQL = rsTrImob.nrdoc
   datadocmSQL = rsTrImob.datadoc
})


paramsCodClas<<['idFirma':idFirma]
paramsCodClas<<['datainc':datadocmSQL]


// fisierul html cu mesajele de eroare + concluzia de la incercarea de preluare
def fisRezSB = new StringBuilder()
fisRezSB<<"<html><body>"

File fisRezFile = new File(tmpFolder, "blabla.txt")
fisRezFile.createNewFile()

fisRezSB<<"</body></html>"

def errLipsaNrTranz = (nrTranzCamp == null || nrTranzCamp == '')
def errLipsaFileDefTrImobSIN = (fileDefTrImobSIN == null || fileDefTrImobSIN == '')
def errFormatEronatFileDefTrImobSIN = false

if (errLipsaNrTranz || errLipsaFileDefTrImobSIN) {
   if (errLipsaNrTranz) {
      fisRezSB<<"<li>"
      fisRezSB<<"Campul <mark><b>Nr. Tranzactie SIN</b></mark>:"
      
      fisRezSB<<"<br>"
      fisRezSB<<"Eroare:"
      
      fisRezSB<<"<br>"
      fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Campul nu este completat."
      
      fisRezSB<<"<br>"
      fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Nr. Tranzactie Sold Initial este obligatoriu!"
      fisRezSB<<"</li>"
      
      fisRezSB<<"<br>"
   }
   
   if (errLipsaFileDefTrImobSIN) {
      fisRezSB<<"<li>"
      fisRezSB<<"Campul <mark><b>Fisier XLS conform model (Imobiliz.xlsx)</b></mark>:"
      
      fisRezSB<<"<br>"
      fisRezSB<<"Eroare:"
      
      fisRezSB<<"<br>"
      fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> In camp nu este incarcat niciun fisier cu date de preluat."
      
      fisRezSB<<"<br>"
      fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Fisierul este obligatoriu!"
      fisRezSB<<"</li>"
      
      fisRezSB<<"<br>"
   }
}


if (errLipsaFileDefTrImobSIN == false) {
   try {
      excelReader.iterateRow(fileDefTrImobSIN, 1, true, {reader ->
         int rowNo = reader.rowNo
         int nrRandDeAfisat = rowNo + 1 /* deoarece Randurile si Coloanele se numara de la zero */
         
         String sheetName = reader.sheetName
         
         if (debug) {
            println("excelReader.iterateRow --> rowNo: ${rowNo}")
         }
         
         if (cloneSheet == null) {
            cloneWb = reader.cloneWorkBook()
            cloneSheet = cloneWb.getSheet(sheetName)
            style = cloneWb.createCellStyle()
            style.setBorderBottom(BorderStyle.MEDIUM)
            style.setBottomBorderColor(IndexedColors.RED.getIndex())
            style.setBorderLeft(BorderStyle.MEDIUM)
            style.setLeftBorderColor(IndexedColors.RED.getIndex())
            style.setBorderRight(BorderStyle.MEDIUM)
            style.setRightBorderColor(IndexedColors.RED.getIndex())
            style.setBorderTop(BorderStyle.MEDIUM)
            style.setTopBorderColor(IndexedColors.RED.getIndex())
         }
         
        
        
         def rowFieldContext = [:]
         
         StringBuilder msgsErrorGetVal = new StringBuilder()
         def existaMsgsErrorGetVal = false
         
         /* --> Definire closure "completeazaMap" */
         def completeazaMap = {String numeColoanaXLS, String fieldEmsys, String dataType, int nrZec = 0 ->
            def rowContext = [:]
            def val = null
            def errorGetVal = null
            def msgErrorGetVal = null
            
            switch(dataType) {
             case tipDataCalend:
              try {
                 val = reader.getDate(numeColoanaXLS, 'dd.MM.yyyy')
              } catch (error) {
                 errorGetVal = error
              }
              
              if (errorGetVal != null) {
                 errorGetVal = null
                 
                 try {
                    val = reader.getDate(numeColoanaXLS, 'dd/MM/yyyy')
                 } catch (error) {
                    errorGetVal = error
                 }
              }
              
              if (errorGetVal != null) {
                 errorGetVal = null
                 
                 try {
                    val = reader.getDate(numeColoanaXLS, 'dd-MM-yyyy')
                 } catch (error) {
                    errorGetVal = error
                 }
              }
              
              break
             
             case tipNumeric:
              try {
                 val = reader.getNumber(numeColoanaXLS)
                 if (val != null && nrZec >= 0) {
                    val = val.setScale(nrZec, RoundingMode.HALF_UP)
                 }
              } catch (error) {
                 errorGetVal = error
              }
              break
             
             case tipString:
              try {
                 val = reader.getString(numeColoanaXLS)
              } catch (error) {
                 errorGetVal = error
              }
              break
             
             default:
              break
            }
            
            def poz = reader.findPosition(numeColoanaXLS)
            def clonedRow = cloneSheet.getRow(rowNo)
            def content = ['cell':poz, 'field':fieldEmsys, 'xlsField':numeColoanaXLS, 'value':val, 'poiCell':clonedRow.getCell(poz)]
            rowContext.put(numeColoanaXLS, content)
            rowFieldContext.put(fieldEmsys, content)
            
            if (debug) {
               println("poz ${poz} - ${numeColoanaXLS}: ${fieldEmsys} - ${val} - ${(val == null) ? null : val.class} - ${errorGetVal}")
            }
            
            if (errorGetVal != null) {
               if (existaMsgsErrorGetVal == false) {
                  msgsErrorGetVal<<"<u>Citirea valorilor de pe rand</u>:"
               } else {
                  msgsErrorGetVal<<"<br>"
                  msgsErrorGetVal<<" "
               }
               
               switch(dataType) {
                case tipDataCalend:
                 msgErrorGetVal = "valoarea din celula (<b>${content.poiCell}</b>) nu poate fi citita corect ca <b>Data Calendaristica</b><br><span style=\"color:White;\">${spatiiStangaMsg}</span> in niciunul din formatele: <b>dd.MM.yyyy</b>, <b>dd/MM/yyyy</b>, <b>dd-MM-yyyy</b> (unde <b>dd</b> = ziua cu 2 cifre, <b>MM</b> = luna cu 2 cifre, <b>yyyy</b> = anul cu 4 cifre)"
                 break
                
                case tipNumeric:
                 msgErrorGetVal = "valoarea din celula (<b>${content.poiCell}</b>) nu poate fi citita corect ca <b>Numar</b>"
                 break
                
                case tipString:
                 msgErrorGetVal = "valoarea din celula (<b>${content.poiCell}</b>) nu poate fi citita corect ca <b>Sir de Caractere</b>"
                 break
                
                default:
                 break
               }
               
               msgsErrorGetVal<<"<br>"
               msgsErrorGetVal<<"Eroare la campul <b>${content.xlsField}</b> (coloana <b>${content.cell + 1}</b>):"
               
               msgsErrorGetVal<<"<br>"
               msgsErrorGetVal<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> ${msgErrorGetVal}"
               
               msgsErrorGetVal<<"<br>"
               msgsErrorGetVal<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> (valoare citita <b>${content.value}</b>: <span style=\"color:DarkGrey;\">${errorGetVal}</span>)."
               
               def rowField = rowFieldContext[fieldEmsys]
               
               if (rowField != null) {
                  if (debug) {
                     println("rowField.poicell (la citire valori rand): ${rowField.poiCell}")
                  }
                  
                  def varPoicell = rowField.poiCell
                  
                  if (debug) {
                     println("varPoicell (la citire valori rand): ${varPoicell}")
                  }
                  
                  if (varPoicell != null) {
                     varPoicell.setCellStyle(style)
                  }
               }
               
               existaMsgsErrorGetVal = true
            }
            
            return content
         }
         /* <-- Definire closure "completeazaMap" */

         def nrinvent = completeazaMap("Numar inventar", 'nrinvent', tipNumeric, -1/*ramane valoarea (as it is)*/).value

         def denimob = completeazaMap("Denumire", 'denimob', tipString).value
         if (denimob){
           denimob = denimob.replaceAll("'", "")
           denimob = denimob.replaceAll("\"", "")
         }
         def gestPr = completeazaMap("Gestiune", 'gestPr', tipNumeric, -1).value
         def codclas = completeazaMap("Cod clasificare", 'codclas', tipString).value
         def datapf = completeazaMap("Data punere functiune", 'datapf', tipDataCalend).value

         def valimobb = completeazaMap("Valoare Inventar RON", 'valimobb', tipNumeric, 2).value

         def valamb = completeazaMap("Valoare Amortizare RON", 'valamb', tipNumeric, 2).value

         def zonach = completeazaMap("Zona", 'zonach', tipNumeric, -1).value
         def purtch = completeazaMap("Purtator", 'purtch', tipString).value

         def regamortiz = completeazaMap("Regim amortizare", 'regamortiz', tipString).value

         def dataincam = completeazaMap("Data inceput calcul amortizare", 'dataincam', tipDataCalend).value

         def dun = completeazaMap("DN A", 'dun', tipNumeric, -1).value
         def dulege = completeazaMap("Durata Amortizare Ani", 'dulege', tipNumeric, -1).value
         def dulegel = completeazaMap("Durata Amortizare Luni", 'dulegel', tipNumeric, -1).value

         def contContintr = completeazaMap("Cont imobilizare", 'contContintr', tipString).value

         def contAmdedintr = completeazaMap("Cont amortizare", 'contAmdedintr', tipString).value

         def contCheltded = completeazaMap("Cont cheltuiala", 'contCheltded', tipString).value

         def contDifreevintr = completeazaMap("Cont rezerve", 'contDifreevintr', tipString).value

         def codpartFurn = completeazaMap("Furnizor provenienta", 'codpartFurn', tipString).value
         def coddocFurn = completeazaMap("Document Provenienta", 'coddocFurn', tipString).value
         def nrdocfurn = completeazaMap("Numar Document Provenienta", 'nrdocfurn', tipNumeric, -1).value
         def datadocfurn = completeazaMap("Data Document Provenienta", 'datadocfurn', tipDataCalend).value
         
         def caractTeh, accesorii, codlistaDmf, codlistaRezidentapr, marca, sectie, atelier, nrinventext, nrinventanterior, dataInv, impozit, codjud, codloc
         
         if (reader.headers.contains("CARACTERISTICI TEHNICE")) {
           caractTeh = completeazaMap("Caracteristici tehnice", 'caractTeh', tipString).value
         }
         if (reader.headers.contains("ACCESORII")) {
           accesorii = completeazaMap("Accesorii", 'accesorii', tipString).value
           if (accesorii){
               accesorii = accesorii.replaceAll("'", "")
               accesorii = accesorii.replaceAll("\"", "")
             }
         }
         if (reader.headers.contains("DOMENIU")) {
           codlistaDmf = completeazaMap("Domeniu", 'codlistaDmf', tipString).value
         }
         if (reader.headers.contains("REZIDENTA")) {
           codlistaRezidentapr = completeazaMap("Rezidenta", 'codlistaRezidentapr', tipString).value
         }
         if (reader.headers.contains("MARCA")) {
           marca = completeazaMap("Marca", 'marca', tipNumeric, -1).value
         }
         if (reader.headers.contains("DEPARTAMENT")) {
           sectie = completeazaMap("Departament", 'sectie', tipString).value
         }
         if (reader.headers.contains("SUBDEPARTAMENT")) {
           atelier = completeazaMap("Subdepartament", 'atelier', tipString).value
         }
         if (reader.headers.contains("NUMAR INVENTAR EXTERN")) {
           nrinventext = completeazaMap("Numar inventar extern", 'nrinventext', tipString).value
         }
         if (reader.headers.contains("NUMAR INVENTAR ANTERIOR")) {
           nrinventanterior = completeazaMap("Numar inventar anterior", 'nrinventanterior', tipNumeric, -1).value
         }
         if (reader.headers.contains("DATA ULTIMULUI INVENTAR")) {
           dataInv = completeazaMap("Data ultimului inventar", 'dataInv', tipDataCalend).value
         }
         if (reader.headers.contains("IMPOZIT")) {
           impozit = completeazaMap("Impozit", 'impozit', tipString).value
         }
         if (reader.headers.contains("JUDET")) {
           codjud = completeazaMap("Judet", 'codjud', tipString).value
         }
         if (reader.headers.contains("LOCALITATE")) {
           codloc = completeazaMap("Localitate", 'codloc', tipString).value
         }
           
         
         if (impozit == null && codjud == null && codloc == null) {
           impozit = impozitValFixa
         }
           
         def codclasGr = null
         if (codclas != null) {
            def indexPunct = codclas.indexOf('.')
            if (indexPunct >= 0) {
               codclasGr = codclas.substring(0, indexPunct + 1)
                      // + 1 deoarece:
                      // String substring(int beginIndex, int endIndex) Returns a new string that is a substring of this string.
                      // The substring begins at the specified beginIndex and extends to the character at index endIndex - 1.
            } else {
               codclasGr = ''
            }
         }
         
         def tipimobilizSQL = null
         
         paramsCodClas<<['codclas':codclas]
         
         sql.eachRow(sqlSelectCodClas, paramsCodClas, {rsCodClas ->
            if (debug) {
               println("TipImobiliz = ${rsCodClas.tipimobiliz}; ContAmDedIntr = ${rsCodClas.contamortiz}")
            }
            
            tipimobilizSQL = rsCodClas.tipimobiliz
            
            if (contAmdedintr == null) {
               contAmdedintr = rsCodClas.contamortiz
            }
         })
         
         if (tipimobilizSQL == null) // i.e. Codul de Clasificare din fisierul cu date de preluat nu exista in Baza de Date
           {
            tipimobilizSQL = 'MIJLOACE FIXE' // Se atribuie o valoare <> null, pt. a evita:
                                             // - aparitia mesajului de eroare "Valoare obligatorie."
                                             //   relativ la "Tip Imobilizare" (existent doar in "Obiect")
                                             // - lipsa mesajului de eroare (tinand cont de regulile din Emsys pt.
                                             //                              emiterea mesajelor la validarea unei inregistrari)
                                             //   relativ la "Cod Clasificare" (existent si in fisier, si in "Obiect").
         }
         
         inregTotale++
         
         def mapDefTrImobSIN = [:]
         mapDefTrImobSIN<<[
                           'idFirma' : idFirma,
                           'idUser' : idUser,
                           'idProfil' : idProfil,
                           // 'dataoper' : new java.util.Date(), // Poate lipsi de aici.
                           
                           'idAnfiscal' : idAnfiscalSQL,
                           'idPerioada' : idPerioadaSQL,
                           'nrtranz' : nrTranzCamp,
                           
                           // 'tiptranz' : tiptranzValFixa, // Poate lipsi de aici.
                           // 'tipdoc' : tipdocValFixa, // Poate lipsi de aici.
                           
                           /* --> Necesar in Server-ul pt. DefTrImob
                                  (SERVICEIMPL, VALIDATOR - "DefTrimobServiceImpl", "DeftrimobValidatorSIN"),
                                  NU poate lipsi de aici. */
                           'stare' : stareValFixa,
                           /* <-- Necesar in Server-ul pt. DefTrImob
                                  (SERVICEIMPL, VALIDATOR - "DefTrimobServiceImpl", "DeftrimobValidatorSIN"),
                                  NU poate lipsi de aici. */
                           
                           // 'qdoc' : qdocValFixa, // Poate lipsi de aici.
                           
                           /* --> Necesare in Server-ul pt. DefTrImob
                                  (SERVICEIMPL, VALIDATOR - "DefTrimobServiceImpl", "DeftrimobValidatorSIN"),
                                  NU pot lipsi de aici. */
                           'tipint' : tipintValFixa,
                           'tiptranzactie' : tiptranzactieValFixa,
                           'stornat' : stornatValFixa, // Daca nu s-ar trimite in Server
                                                       // DEFTRIMOB.Stornat ar fi completat automat cu valoarea NULL.
                           'ramanemf' : ramanemfValFixa, // Daca nu s-ar trimite in Server
                                                         // DEFTRIMOB.RamaneMF ar fi completat automat cu valoarea NULL.
                           'calcamfisc' : calcamfiscValFixa,
                           'impozit' : impozit,
                           'calcamalt' : calcamaltValFixa,
                           /* <-- Necesare in Server-ul pt. DefTrImob
                                  (SERVICEIMPL, VALIDATOR - "DefTrimobServiceImpl", "DeftrimobValidatorSIN"),
                                  NU pot lipsi de aici. */
                           
                           'nrinvent' : nrinvent,
                           'denimob' : denimob,
                           'gestPr' : gestPr,
                           'codclas' : codclas,
                           'datapf' : datapf,
                           
                           'valimobb' : valimobb,
                           'valdocb' : valimobb,
                           'valintrb' : valimobb,
                           'valimobaltb' : valimobb,
                           'valdocaltb' : valimobb,
                           'valintraltb' : valimobb,
                           
                           'valamb' : valamb,
                           'valamdedb' : valamb,
                           'valamaltb' : valamb,
                           
                           'zonach' : zonach,
                           'purtch' : purtch,
                           
                           'regamortiz' : regamortiz,
                           'regamortizalt' : regamortiz,
                           
                           'dataincam' : dataincam,
                           'dataincamalt' : dataincam,
                           
                           'dun' : dun,
                           
                           'dulege' : dulege,
                           'dulegealt' : dulege,
                           
                           'dulegel' : dulegel,
                           'dulegelalt' : dulegel,
                           
                           'contContintr' : contContintr,
                           'cont' : contContintr,
                           
                           'contAmdedintr' : contAmdedintr,
                           'contAmnedintr' : contAmdedintr,
                           
                           'contCheltded' : contCheltded,
                           'contCheltned' : contCheltded,
                           
                           'contDifreevintr' : contDifreevintr,
                           'contCtdifreevnedintr' : contDifreevintr,
                           
                           'codpartFurn' : codpartFurn,
                           'coddocFurn' : coddocFurn,
                           'nrdocfurn' : nrdocfurn,
                           'datadocfurn' : datadocfurn,
                           
                           'codclasGr' : codclasGr,
                           'tipimobiliz' : tipimobilizSQL,
                           
                           'coddocM' : coddocMSQL,
                           'nrdocm' : nrdocmSQL,
                           'datadocm' : datadocmSQL,
             
                           'caractTeh': caractTeh, 
                           'accesorii' :accesorii,
                           'codlistaDmf' :codlistaDmf, 
                           'codlistaRezidentapr' :codlistaRezidentapr,
                           'marca': marca,
                           'sectie' :sectie, 
                           'atelier'  :atelier, 
                           'nrinventext': nrinventext,
                           'nrinventanterior':nrinventanterior,
                           'dataInv': dataInv,
                           'codjud' :codjud,
                           'codloc' :codloc,
                           'impex' : true
                           ]
         
         def returnRowObj = null
         
         def argsDefTrImobSIN = [locale, mapDefTrImobSIN]
         def returnObjectDefTrImobSIN =
                   jsonRemoting.invokeRemote("EMSYS_ASSETS", "defTrimobService", "insert", argsDefTrImobSIN)
         returnRowObj = returnObjectDefTrImobSIN.remoteRowObject
         
           println"returnObjectDefTrImobSIN ${returnObjectDefTrImobSIN}"
           println"returnRowObj ${returnRowObj}"
           println"mapDefTrImobSIN ${mapDefTrImobSIN}"
         
         if (returnRowObj == null) {
            suntErr = true
            randuriIgnorate++
            StringBuilder msgs = new StringBuilder()
            
            msgs<<"<mark>Set mesaje nr. <b>${randuriIgnorate + inregNecorespunzatoare}</b></mark> - Rand nr. <b>${nrRandDeAfisat}</b> / <b>${nrRandDeAfisat}</b>, Sheet (foaie) <b>${sheetName}</b>, fisier cu date de preluat / fisier <b>${numeFisErr}</b>:"
            
            if (existaMsgsErrorGetVal) {
               msgs<<"<br>"
               msgs<<msgsErrorGetVal.toString()
               
               msgs<<"<br>"
               msgs<<" "
            }
            
            msgs<<"<br>"
            msgs<<"<u>Incercarea de preluare a randului in Baza de Date</u>:"
            
            msgs<<"<br>"
            msgs<<"Eroare:"
            
            msgs<<"<br>"
            msgs<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Randul a fost verificat, dar rezultatul <b>'returnRowObj'</b> este <b>null</b>. Prin urmare randul este ignorat si de la Adaugare, si de la Erori."
            
            msgs<<"<br>"
            msgs<<" "
            
            mesajeList<<msgs.toString()
            
            return
         }
         
         if (returnRowObj.containsErrors() || existaMsgsErrorGetVal || returnRowObj.containsWarnings()) {
            if (returnRowObj.containsErrors() || existaMsgsErrorGetVal) {
               suntErr = true
               inregNecorespunzatoare++
            }
             
            if (returnRowObj.containsWarnings()) {
               suntWrn = true
            }
            
            StringBuilder msgs = new StringBuilder()
            
            msgs<<"<mark>Set mesaje nr. <b>${randuriIgnorate + inregNecorespunzatoare}</b></mark> - Rand nr. <b>${nrRandDeAfisat}</b> / <b>${nrRandDeAfisat}</b>, Sheet (foaie) <b>${sheetName}</b>, fisier cu date de preluat / fisier <b>${numeFisErr}</b>:"
            
            if (existaMsgsErrorGetVal) {
               msgs<<"<br>"
               msgs<<msgsErrorGetVal.toString()
               
               msgs<<"<br>"
               msgs<<" "
            }
            
            msgs<<"<br>"
            msgs<<"<u>Incercarea de preluare a randului in Baza de Date</u>:"
            
            returnRowObj.messageList.each {emsMgs ->
               def titluMsgString = null
               
               switch (emsMgs.messageType) {
                case EmsysMessage.FATAL_ERROR_MESSAGE:
                 titluMsgString = "Eroare fatala"
                 break
                
                case EmsysMessage.ERROR_MESSAGE:
                 titluMsgString = "Eroare"
                 break
                
                case EmsysMessage.WARNING_MESSAGE:
                 titluMsgString = "Avertisment"
                 break
                
                case EmsysMessage.INFORMATION_MESSAGE:
                 titluMsgString = "Info"
                 return // break /* daca se doreste si afisarea mesajelor "Info") */
                
                default:
                 titluMsgString = "Mesaj"
                 return // break /* daca se doreste si afisarea mesajelor de alt tip decat cele de mai sus) */
               }
               
               if (emsMgs.field == null) {
                  msgs<<"<br>"
                  msgs<<"${titluMsgString}:"
                  
                  msgs<<"<br>"
                  msgs<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> ${emsMgs.message}"
                  
                  msgs<<"<br>"
                  msgs<<" "
                  
                  if (debug) {
                     println("Obiect Mesaje Emsys: ${emsMgs}")
                     println("Mesaj Emsys: ${emsMgs.message}")
                  }
               } else {
                  def fiedlLabel = fields[emsMgs.field]
                  def rowField = rowFieldContext[emsMgs.field]
                  
                  msgs<<"<br>"
                  
                  if (rowField != null) {
                     if (debug) {
                        println("rowField.poicell (la incercare preluare rand): ${rowField.poiCell}")
                     }
                     
                     def varPoicell = rowField.poiCell
                     
                     if (debug) {
                        println("varPoicell (la incercare preluare rand): ${varPoicell}")
                     }
                     
                     if (varPoicell != null) {
                        varPoicell.setCellStyle(style)
                     }
                     
                     msgs<<"${titluMsgString} la campul <b>${rowField.xlsField}</b> (coloana <b>${rowField.cell + 1}</b>, valoare citita <b>${rowField.value}</b>, valoare celula <b>${rowField.poiCell}</b>):"
                     
                     msgs<<"<br>"
                     msgs<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> ${emsMgs.message}"
                  } else {
                     msgs<<"${titluMsgString} la campul <b>${fiedlLabel}</b>:"
                     
                     msgs<<"<br>"
                     msgs<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> ${emsMgs.message}"
                  }
                  
                  msgs<<"<br>"
                  msgs<<" "
               }
            }
            
            mesajeList<<msgs.toString()
            }
            
           if (!returnRowObj.containsErrors() && !existaMsgsErrorGetVal) {
               liniiOK<<rowNo
               inregAdaugate++
            }
            
           if (returnRowObj.values['id'] != null) {
             iduriInregAdaugate<<returnRowObj.values['id']
           }
           
            if (debug) {
               println("Obiectul contine erori ::: ${returnRowObj.containsErrors()}")
               println("Obiectul contine avertismente ::: ${returnRowObj.containsWarnings()}")
            }
      })
   } catch (error) {
      errFormatEronatFileDefTrImobSIN = true
      
      fisRezSB<<"<li>"
      fisRezSB<<"Campul <mark><b>Fisier XLS conform model (Imobiliz.xlsx)</b></mark>:"
      
      fisRezSB<<"<br>"
      fisRezSB<<"Eroare:"
      
      fisRezSB<<"<br>"
      fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Fisierul incarcat nu are format tabelar Excel (.XLSX, .XLS):"
      
      fisRezSB<<"<br>"
      fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg} ${spatiiStangaMsg} ${spatiiStangaMsg}</span> <span style=\"color:DarkGrey;\">${error}</span>."
      
      fisRezSB<<"<br>"
      fisRezSB<<" "
      
      fisRezSB<<"<br>"
      fisRezSB<<"<span style=\"color:White;\">${spatiiStangaMsg}</span> Fisierul incarcat trebuie sa aiba obligatoriu format tabelar Excel!"
      fisRezSB<<"</li>"
      
      fisRezSB<<"<br>"
   }
}

if (errLipsaNrTranz || errLipsaFileDefTrImobSIN || errFormatEronatFileDefTrImobSIN) {
   fisRezSB<<"<b>Preluarea randurilor <mark>nu</mark> s-a realizat cu succes. <mark>Exista erori!</mark></b>"
   
   fisRezSB<<"</body></html>"
   
   fisRezFile.text = fisRezSB.toString()
   attachFile("Lista_Mesaje_pt_Informatii_Interfata.html", fisRezFile)
   
   return
}


if (debug) {
   println("mesajeList::: " + mesajeList)
}

if (debug) {
   println("Randuri corecte: ${liniiOK}")
}

mesajeList.eachWithIndex {msg, index ->
   if (index > 0) {
      fisRezSB<<"<br>"
   }
   
   fisRezSB<<"<li>${msg.toString()}</li>"
}

if (suntErr || suntWrn) {
   fisRezSB<<"<br>"
}

fisRezSB<<"<p style=\"color:DodgerBlue;\"> <b>Inregistrari totale: ${inregTotale}</b> </p>"

if (!suntErr) {
   fisRezSB<<"<p style=\"color:MediumSeaGreen;\"> <b>Inregistrari adaugate cu succes: ${inregAdaugate}</b> </p>"
} else {
   fisRezSB<<"<p style=\"color:MediumSeaGreen;\"> <b>Inregistrari fara erori: ${inregAdaugate}</b> </p>"
   
   def sqlDeleteDefTrImob = """
       DELETE TOTAL.DEFTRIMOB
       WHERE TOTAL.DEFTRIMOB.ID_FIRMA = :idFirma
         AND TOTAL.DEFTRIMOB.ID = :idDefTrImob
       """
   
   def paramsDefTrImob = [:]
   paramsDefTrImob<<['idFirma':idFirma]
   
   iduriInregAdaugate.each {idInregAdaugata ->
      paramsDefTrImob<<['idDefTrImob':idInregAdaugata]
      
      sql.executeUpdate(sqlDeleteDefTrImob, paramsDefTrImob)
   }
}

fisRezSB<<"<p style=\"color:Tomato;\"> <b>Inregistrari cu erori: ${inregNecorespunzatoare}</b> </p>"

fisRezSB<<"<p style=\"color:Grey;\"> <b>Randuri ignorate: ${randuriIgnorate}</b> </p>"

fisRezSB<<"<br>"

if (!suntErr) {
   if (!suntWrn) {
      fisRezSB<<"<b>Preluarea randurilor s-a realizat cu succes!</b>"
   } else {
      fisRezSB<<"<b>Preluarea randurilor s-a realizat cu succes, dar pentru anumite randuri exista <mark>avertismente</mark>.</b>"
   }
} else {
   fisRezSB<<"<b>Preluarea randurilor <mark>nu</mark> s-a realizat cu succes. <mark>Exista erori!</mark></b>"
   if (suntWrn) {
      fisRezSB<<"<br>"
      fisRezSB<<"<p><b>De asemenea, pentru anumite randuri exista <mark>avertismente</mark>.</b></p>"
   }
}

fisRezSB<<"</body></html>"

fisRezFile.text = fisRezSB.toString()
attachFile("Lista_Mesaje_Rezultate_Incercare_Preluare.html", fisRezFile)

if (suntErr) {
   File fisXLS = new File(tmpFolder,'errwwwws.xlsx')
   fisXLS.withOutputStream{os ->
      cloneWb.write(os)
   }
   attachFile(numeFisErr, fisXLS)
}


public void generateFieldDefinition(Locale locale, ErpGroovyTemplatesService.Definition definition) {
 def stringFieldNrTranz = definition.addStringField('nrTranz', 'Nr. Tranzactie SIN', '')
    .setMandatory(false) /* Optional,
                            deoarece obligativitatea se trateaza prin mesaj explicit in fisier de erori, pt. siguranta.
                            
                            Pe de alta parte, exista urmatoarea problema:
                            - dupa ce se completeaza campul cu o valoare prin preluare din F1,
                              se poate modifica valoarea ecran sau chiar sterge cu totul, dar valoarea stocata de sistem ca aferenta campului ramane cea de dinainte;
                              aceasta neconcordanta induce o posibila nedumerire a utilizatorului care examineaza, comparativ, ecranul cu datele introduse si fisierul de rezultate care apare dupa actionarea butonului "Execute";
                            - comportamentul descris mai sus nu poate fi corectat deocamdata (Miercuri 10.11.2021).*/
    .setQueryGenerator({context ->
        StringBuilder sqlSelectLOVTrImob = new StringBuilder()
        
        context.parameters['idFirma'] = idFirma // NB: Este posibil ca acest lucru sa fie deja realizat automat,
                                                //     dar ramane si scris in clar, pt. siguranta.
        
        sqlSelectLOVTrImob<<"""
         SELECT
          TRIMOB.NRTRANZ,
          (CONCAT(DOCUMENT.CODDOC,
            CONCAT(' ',
             CONCAT(TRIMOB.NRDOC,
              CONCAT(' / ',
                     ${sqlUtils.sqlDialect.dateToChar('TRIMOB.DATADOC')})
                     )
                   )
                  )
           ) DESCRIERE_TRANZ
         FROM
          TOTAL.TRIMOB TRIMOB,
          TOTAL.DOCUMENT DOCUMENT
         WHERE TRIMOB.ID_FIRMA   = :idFirma
           AND TRIMOB.TIPDOC     = 'SIN'
           AND TRIMOB.POSTAT     = 'NU'
           AND DOCUMENT.ID_FIRMA = TRIMOB.ID_FIRMA
           AND DOCUMENT.ID       = TRIMOB.ID_CODDOC
        """
        
        if (!context.nullValue) {
           sqlSelectLOVTrImob<<" AND TRIMOB.NRTRANZ LIKE :CONTAINSVALUE"
                               // NB: parametrul CONTAINSVALUE tb. scris cu litere mari.
        }
        
         if(sqlUtils.getDatabaseType() != SqlUtils.TYPE_SQLSERVER){
          sqlSelectLOVTrImob<<"""
           ORDER BY
            TRIMOB.NRTRANZ
          """
         }
        
        return sqlSelectLOVTrImob
     })
    .setResultExtractor({row->
        row.setValueRow(row.resultSet.getString("NRTRANZ"), row.resultSet.getString("DESCRIERE_TRANZ"))
     })
 
 definition.addUploadField('imobiliz', 'Fisier XLS conform model (Imobiliz.xlsx)').setOrder(20)
}



import org.apache.poi.ss.usermodel.IndexedColors
import org.apache.poi.ss.usermodel.CellStyle
import org.apache.poi.ss.usermodel.BorderStyle
import org.apache.poi.ss.usermodel.FillPatternType
import org.apache.poi.hssf.usermodel.HSSFCellStyle
import java.math.RoundingMode
import com.prodinf.core.dataset.EmsysMessage
import com.prodinf.core.sql.SqlUtils